import pandas as pd
import numpy as np
import scipy.stats as ss
import matplotlib.pyplot as plt
import japanize_matplotlib

"""
           Excelファイルからの読み込み
"""
in_file_name = input('入力データファイル(*.xlsx) = ')
xlsx = pd.ExcelFile(in_file_name)
data_xlsx = pd.read_excel(xlsx)

f = open('Results.txt', 'w')
f.write('\n入力データファイル = ' + in_file_name)

keys = data_xlsx.keys()
case_name = keys[0]
case_id = [ v for v in data_xlsx[case_name]]
print(case_id)

y_name = keys[1]
y = [v for v in data_xlsx[y_name]]
print(y)

x_name = keys[2]
xv = [v for v in data_xlsx[x_name]]
xv = np.array(xv)
xv_c = xv - np.mean(xv)
f.write('\nデータ...')
f.write(f'\n{case_name:<15s}{y_name:<15s}{x_name:<15s}{"（中心化値）":<15s}')
for i in range(len(case_id)):
    f.write(f'\n{case_id[i]:<15s}{y[i]:<15.2f}{xv[i]:<15.2f}{xv_c[i]:<15.2f}')


X = np.stack([np.ones(len(xv_c)), xv_c]).T
print(X)

b = np.linalg.inv(X.T @ X) @ X.T @ y              #   式（5.1.5）
print('b =', b)
f.write(f'\n\n定数 = {b[0]:.3f}     傾き = {b[1]:.3f}')

r = ss.pearsonr(xv_c, y)[0]
print('r =', r)
R2 = r**2                                #   決定係数
print('R^2 =', R2)

f.write(f'\n\n決定係数 = {R2:.5f}       相関係数 = {r:.5f}\n')

plt.plot(xv_c, y, 'o')
xvc_min = np.min(xv_c)
xvc_max = np.max(xv_c)
plt.plot([xvc_min, xvc_max], [b[0] + b[1]*xvc_min, b[0] + b[1]*xvc_max],
         label = f'Y = {b[0]:.2f} + {b[1]:.2}*X')
for i in range(len(case_id)):
    plt.text(xv_c[i], y[i], case_id[i])
plt.xlabel(x_name + '（中心化値）')
plt.ylabel(y_name)
plt.title(f'$R^2 = {R2:.3f}$')
plt.legend()
plt.savefig('FigGraph.png')
plt.show()
print('FigGraph.png was saved.')

f.close()
print('Results.txt was saved.')
